=== tools/Python/mcplot/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

add_subdirectory(matplotlib)
add_subdirectory(pyqtgraph)
add_subdirectory(svg)
