=== debian/changelog ===
mccode (0.0~git20240801183257.cdaa431+ds5-2) unstable; urgency=medium

  * Bug fix: "please make the build (mostly) reproducible", thanks to
    Chris Lamb (Closes: #1076507) (part of the patch was not needed due to
    upstream changes).

 -- Roland Mas <lolando@debian.org>  Tue, 06 Aug 2024 16:08:22 +0200

mccode (0.0~git20240801183257.cdaa431+ds5-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel FARHI ]
  * Adapt patches to new upstream git HEAD
  * Add man pages and solve many lintian warnings
  * replace doc postinst generation by static generation in d/rules.
  * Bug fix: "ftbfs with GCC-14", thanks to Matthias Klose (Closes:
    #1075261).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 02 Aug 2024 15:21:12 +0200

mccode (0.0~git20240719135548.728fd5e+ds5-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel FARHI ]
  * debian: add webgl-classic 3d viewer, fix doc generation (postinst is needed)
  * debian: update release number
  * debian: fix duplicate links
  * debian: add patch to install common/lib/share

  [ Picca Frédéric-Emmanuel ]
  * Trim trailing whitespace.
  * New upstream version 0.0~git20240719135548.728fd5e+ds5
  * d/patches: refresh patch series

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 19 Jul 2024 17:18:51 +0200
