=== debian/control ===
Source: mccode
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Roland Mas <lolando@debian.org>,
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-cmake,
 dh-python,
 flex,
 gfortran,
 pandoc,
 python3-all,
 recode,
Standards-Version: 4.6.2
Homepage: https://github.com/McStasMcXtrace/McCode
Vcs-Browser: https://salsa.debian.org/science-team/mccode
Vcs-Git: https://salsa.debian.org/science-team/mccode.git
Rules-Requires-Root: no

# mcstas base packages ---------------------------------------------------------

Package: mcstas
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Neutron ray-trace simulation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas engine itself.

Package: mcstas-comps
Architecture: any
Depends:
 cif2hkl,
 libgsl-dev,
 libmcpl-dev,
 mcpl,
 mcstas,
 ${misc:Depends},
Description: Neutron ray-trace simulation - components
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas components (i.e. models for
 simulated instruments and objects).

Package: mcstas-mccodelib
Architecture: any
Depends:
 gedit,
 mcstas,
 mcstas-comps,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - Python code library
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains Python libraries.

Package: mcstas-mcdoc
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - documentation browser
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcdoc, a tool to display documentation for
 McStas itself and for the simulated instruments.

Package: mcstas-manuals
Architecture: any
Depends:
 mcstas-mcdoc,
 ${misc:Depends},
Description: Neutron ray-trace simulation - documentation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the documentation.

Package: mcstas-mcrun
Architecture: any
Depends:
 gcc,
 mcstas-manuals,
 mcstas-mccodelib,
 python3,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - runner
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcrun, the command-line tool to run the
 McStat simulations.

Package: mcstas-mcgui
Architecture: any
Depends:
 mcstas-mcrun,
 python3,
 python3-pyqt5,
 python3-pyqt5.qsci,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - GUI
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the graphical user interface.

Package: mcstas-clusterscripts
Architecture: any
Depends:
 mcstas-mcrun,
 ${misc:Depends},
 ${perl:Depends},
Description: Neutron ray-trace simulation - parallelization scripts
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains scripts to run McStas in parallel on various
 types of clusters.

# mcstas plot tools ------------------------------------------------------------

Package: mcstas-mcplot-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matplotlib
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-matplotlib,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matplotlib plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the Matplotlib plotting frontend for the
 simulation results.

Package: mcstas-mcplot-svg
Architecture: any
Depends:
 libjs-d3,
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
Description: Neutron ray-trace simulation - SVG plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the SVG plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matlab
Architecture: any
Depends:
 mcstas-mccodelib,
 octave,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matlab/Octave plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains a Matlab/Octave frontend for the simulation
 result viewer.

# mcstas display tools ---------------------------------------------------------

Package: mcstas-mcdisplay-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph frontend for the instrument
 display.

Package: mcstas-mcdisplay-webgl
Architecture: any
Depends:
 libjs-three,
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - WebGL instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
